<template>
	<div class="no-block-spacing">
		<ProviderRecaptcha
			v-slot="{ runRecaptcha, recaptchaReset }"
			:recaptcha-container-id="recaptchaContainerId"
			wait-to-initialize
		>
			<template v-if="!submittedSuccess">
				<template v-for="(slice, index) in page.slices">
					<BlockPageBanner
						v-if="slice.sliceType === 'PageBanner'"
						:key="index"
						v-bind="slice.props"
						:critical="index < 2"
					/>

					<div v-if="slice.sliceType === 'ContentDownloadForm'" :key="index">
						<FormSpecRenderer
							:ref="`formSpecRenderer-${index}`"
							:spec="getFormSpec(index)"
							:is-working="isWorking"
							cta-text="Download PDF"
							style-variation="secondary"
							@submit="
								(data) =>
									submit(
										data,
										runRecaptcha,
										recaptchaReset,
										`recaptcha-container-${index}`,
										`formSpecRenderer-${index}`
									)
							"
						>
							<template #header>
								<h2 :class="$style.header">Sign up to download the PDF guide</h2>
								<span :class="$style.headerSeparator" />
							</template>
							<template #error>
								<div v-if="error" role="alert" :class="$style.error">
									{{ error }}
								</div>
							</template>
						</FormSpecRenderer>
						<div :id="`recaptcha-container-${index}`" />
					</div>

					<BlockMultiColumnLayout
						v-else-if="slice.sliceType === 'MultiColumnLayout'"
						:key="index"
						:critical="index < 2"
						v-bind="slice.props"
					/>
				</template>
			</template>

			<template v-else>
				<template v-for="(slice, index) in page.downloadPdf">
					<BlockPageBanner
						v-if="slice.sliceType === 'PageBanner'"
						:key="index"
						v-bind="slice.props"
						:critical="index < 2"
					/>
					<BlockMultiColumnLayout
						v-else-if="slice.sliceType === 'MultiColumnLayout'"
						:key="index"
						:critical="index < 2"
						v-bind="slice.props"
					/>
					<div v-else-if="slice.sliceType === 'ThankYouMessage'" id="download-pdf" :key="index" :class="$style.block">
						<h2 :class="$style.header">{{ slice.props.heading }}</h2>
						<div v-rich-content :class="$style.thanksCopy" v-html="slice.props.message" />

						<div v-if="slice.props.ctaLink && slice.props.ctaLink.url" :class="$style.ctaSection">
							<a
								:href="slice.props.ctaLink.url"
								:download="slice.props.ctaLink.name"
								target="_blank"
								:class="$style.cta"
							>
								{{ slice.props.ctaText }}
							</a>
						</div>
					</div>
				</template>
			</template>
		</ProviderRecaptcha>
	</div>
</template>

<script>
import ProviderRecaptcha from '@components/provider-recaptcha';
import BlockPageBanner from '@components/block-page-banner';
import BlockMultiColumnLayout from '@components/block-multi-column-layout';
import FormSpecRenderer from '@components/form-spec-renderer';
import FormInput from '@components/form-input';
import FormSelect from '@components/form-select';
import FormCheckbox from '@components/form-checkbox';
import scrollToHash from '@/utils/scroll-to-hash';
import getMetadata from '@/utils/get-metadata';
import { fromEntries } from '@/utils';
const formComponents = { FormInput, FormSelect, FormCheckbox };

// prettier-ignore
const categories = ['Category','Hospital','Dental','Other Healthcare','Nursing Home','Office','School','Hotel','Gym/Fitness','Salon','Spa','Other'].map(category => ({ value: category, text: category }));

export default {
	components: {
		BlockPageBanner,
		BlockMultiColumnLayout,
		ProviderRecaptcha,
		FormSpecRenderer,
		...formComponents,
	},

	beforeRouteEnter: (to, from, next) =>
		next((vm) => {
			if (!vm.isInitialRoute) vm.previousFullPath = from.fullPath;
		}),

	asyncData: async ({ store, req }) => ({
		page: await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'crrsa_act_education', req }),
		isInitialRoute: process.server,
	}),

	data() {
		return {
			formSpec: [],
			formSpecLabels: {},
			isWorking: false,
			submittedSuccess: false,
			error: '',
			previousFullPath: '',
			recaptchaContainerId: '',
		};
	},

	head() {
		return this.page
			? getMetadata(
					{
						...this.page.seo,
						path: this.$route && this.$route.path,
					},
					this.$sentry
			  )
			: {};
	},

	created() {
		this.formSpec = [
			{
				id: 'first_name',
				component: FormInput,
				label: 'First Name *',
				placeholder: 'First name',
				required: true,
				appearance: 'halfOnDesktop',
				labelHidden: true,
			},
			{
				id: 'last_name',
				component: FormInput,
				label: 'Last Name *',
				placeholder: 'Last name',
				required: true,
				appearance: 'halfOnDesktop',
				labelHidden: true,
			},
			{
				id: 'email',
				component: FormInput,
				type: 'email',
				label: 'Your email *',
				placeholder: 'Email',
				required: true,
				labelHidden: true,
			},
			{
				id: 'organization_name',
				component: FormInput,
				label: 'School name/district *',
				placeholder: 'School name/district',
				required: true,
				labelHidden: true,
			},
			{
				id: 'phone',
				component: FormInput,
				label: 'Phone Number *',
				placeholder: 'Phone Number (XXX-XXX-XXXX)',
				required: true,
				labelHidden: true,
				maxlength: 12,
				pattern: '[0-9]{3}-[0-9]{3}-[0-9]{4}',
				phoneMask: true,
			},
			{
				id: 'industry',
				component: FormSelect,
				type: 'select',
				label: 'Category',
				placeholder: 'Category',
				required: true,
				default: 'Category',
				options: categories,
				labelHidden: true,
				ref: 'industry',
			},
			{
				id: 'Other Industry',
				component: FormInput,
				label: 'Other Category',
				placeholder: 'Other Category',
				labelHidden: true,
				renderCondition: (form) => form.industry === 'Other',
			},
			{
				id: 'Marketing Opt-in',
				component: FormCheckbox,
				type: 'checkbox',
				label: 'Marketing Opt-in',
				default: false,
				labelHidden: false,
				displayLabel:
					'<p>Send me announcements, offers, and sales info on Molekule.</p><p><a href="https://molekule.com/legal">Privacy policy</a></p>',
			},
		];

		this.formSpec.forEach((field) => {
			this.formSpecLabels[field.id] = field.label;
		});
	},

	methods: {
		async submit(formData, runRecaptcha, recaptchaReset, recaptchaContainerId, refName) {
			const { isWorking } = this;
			if (isWorking) return;
			if (formData.industry === 'Category') {
				const {
					[refName]: [formSpecRendererRef],
				} = this.$refs;
				const { industry: industryRef } = formSpecRendererRef.$refs;
				if (industryRef && industryRef.$el) {
					const selectElem = industryRef.$el.querySelector('select');
					selectElem && selectElem.focus();
					selectElem.setAttribute('data-focus-visible-added', '');
				}
				return;
			}
			const { $route, previousFullPath } = this;

			this.recaptchaContainerId = recaptchaContainerId;
			this.isWorking = true;
			this.error = '';

			const formToSubmit = { 'Lead Type': { label: 'Lead Type', value: 'CRRSA Content Download' } };

			Object.entries(formData).forEach(([key, value]) => {
				formToSubmit[key] = {
					label: this.formSpecLabels[key],
					value,
				};
			});

			if ($route.query.utm_source || document.referrer) {
				formToSubmit.channel_source = {
					label: 'Channel source',
					value: $route.query.utm_source || document.referrer,
				};
			}

			if (previousFullPath) {
				formToSubmit.source = {
					label: 'Source',
					value: `${window.location.origin}${previousFullPath}`,
				};
			}

			if (formToSubmit.industry.value !== 'Other' || !formToSubmit['Other Industry'].value) {
				delete formToSubmit['Other Industry'];
			}

			formToSubmit['Marketing Opt-in'].value = formToSubmit['Marketing Opt-in'].value ? 'Yes' : 'No';

			try {
				const recaptchaResponse = await runRecaptcha();

				const response = await this.$axios.$post('/custom-apis/forms/purchase', {
					recaptchaResponse,
					form: formToSubmit,
				});

				if (response.success) {
					this.submittedSuccess = true;
					this.$nextTick(() => {
						if (document.querySelector('#download-pdf')) {
							scrollToHash('#download-pdf');
						} else {
							window.scrollTo(0, 0);
						}
					});

					const formIdsToTealiumPropNames = {
						organization_name: 'lead_business_name',
						industry: 'lead_industry_category',
						'Other Industry': 'lead_industry_category',
						'Marketing Opt-in': 'lead_marketing_opt_in',
					};

					let eventValue = '';
					const leadProperties = fromEntries(
						Object.entries(formToSubmit)
							.map(([key, { value }]) => {
								if (['industry', 'Other Industry'].includes(key)) {
									eventValue = value;
								} else if (['Lead Type', 'channel_source'].includes(key)) {
									return null;
								}

								return [formIdsToTealiumPropNames[key] || `lead_${key}`, value];
							})
							.filter(Boolean)
					);

					this.$tealiumEvent('crrsa_signup', {
						event_category: 'Leads',
						event_action: 'CRRSA Lead Form',
						event_value: eventValue,
						...leadProperties,
					});
				} else {
					throw new Error('returned error');
				}
			} catch (e) {
				this.error = 'Unexpected error occurred. Please try again in a few minutes.';
				recaptchaReset();
			} finally {
				this.isWorking = false;
			}
		},

		getFormSpec(index) {
			return this.formSpec.map((field) => ({
				...field,
				labelFor: `${field.id}-${index}`,
			}));
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.header {
	max-width: 32rem;
	margin: 0 auto 1em;
	font-weight: 300;
	text-align: center;

	@include use-text-style('heading-400');
}

.headerSeparator {
	display: block;
	width: 100%;
	height: 1px;
	background: color('primary-250');
}

.block {
	max-width: 48rem;
	padding: 5rem size('s');
	margin: 0 auto;
	line-height: 1.85714;

	button {
		line-height: 1;
	}
}

.thanksCopy p {
	@include use-text-style('type-500');

	font-weight: 300;
	text-align: center;
}

.ctaSection {
	margin: 3.5rem 0 0;
	text-align: center;
}
.cta {
	position: relative;
	display: inline-block;
	padding: 0.9rem 3rem 0.8rem;
	line-height: 1;
	color: color('white');
	text-align: center;
	background-color: color('button-primary');
	border: 2px solid;
	border-color: color('button-primary');
	border-radius: 1.8rem;
	transition: all 0.25s ease-in-out;

	@include use-text-style('type-100');

	&.isWorking {
		transition: none;
	}

	&:hover,
	&:focus {
		background-color: color('button-primary-hover');
		border-color: color('button-primary-hover');
	}

	&:disabled {
		color: color('primary-200');
		background-color: color('button-disabled');
		border-color: color('button-disabled');
	}
}

.sansSerif {
	font-weight: 300;
	text-align: center;

	@include use-text-style('type-500');
}

.error {
	@include use-text-style('type-300');

	margin-bottom: size('m');
}

[class^='blockContentTop'] {
	@include above('medium') {
		max-width: 69.4rem !important;
		padding: 3.4rem 0 !important;
		margin: 0 auto !important;

		h2 {
			@include use-text-style('heading-650');

			font-size: 3.8rem !important;
			line-height: 1.075 !important;
		}

		p {
			@include use-text-style('type-500');

			font-size: 1.8rem !important;
			line-height: 1.3333 !important;
		}
	}
}

[class^='layers'] [class^='blockContent_'] {
	padding-top: 5.7rem !important;
	padding-bottom: 5.7rem !important;
}
</style>
